// --------------------------------------------------------------------------------------------------------------------
// <copyright file="ICommandLineOption.cs" company="Matthias Friedrich">
//   Copyright  Matthias Friedrich 2013
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace CommandlineHandling
{
    using System;
    using System.Collections.Generic;

    public interface ICommandLineOption
    {
        Func<ICommandLineOption, ICommandLineOption, object> Execute { get; set; }

        string Name { get; set; }

        ICommandLineOption Next { get; set; }

        IList<OptionParameter> Parameters { get; set; }

        string Value { get; set; }

        T Find<T>(bool directFollowerOnly = true) where T : class, ICommandLineOption;

        IEnumerable<T> FindAll<T>(bool directFollowerOnly = true) where T : class, ICommandLineOption;

        object InvokeExecute(ICommandLineOption caller = null);

        OptionParameter Parameter(string name, bool throwException = false);

        IEnumerable<OptionParameter> ParameterList(string name);
    }
}