// --------------------------------------------------------------------------------------------------------------------
// <copyright file="OptionAttribute.cs" company="Matthias Friedrich">
//   Copyright  Matthias Friedrich 2013
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace CommandlineHandling
{
    using System;

    [Serializable()]
    [AttributeUsage(AttributeTargets.Class, Inherited = true, AllowMultiple = true)]
    public class OptionAttribute : Attribute
    {
        public OptionAttribute(string name)
            : base()
        {
            ExceptionExtensions.ThrowArgumentNullException(name, () => name);

            this.Name = name;
        }

        public string Name { get; private set; }
    }
}