﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="Program.cs" company="Matthias Friedrich">
//   Copyright © Matthias Friedrich 2013
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace Sample3
{
    using System.Collections.Generic;

    using CommandlineHandling;

    internal class Program
    {
        // 	sample3.exe /x /a /y /b /c
        private static void Main(string[] args)
        {
            var handler = new CommandLineHandler();

            handler.Register<Options>("x"); // will have /a as input
            handler.Register<Options>("y"); // will have /b /c as input

            handler.Register<InputOption>("a");
            handler.Register<InputOption>("b");
            handler.Register<InputOption>("c");

            IEnumerable<ICommandLineOption> arguments = handler.Parse(args);

            handler.Execute(arguments);
        }
    }
}